/*****************************************************************************\
 *
 * Author: Sauer Vaclav
 * Email:  xsauer00<at>stud.fit.vutbr.cz
 *
 * Bachelors's thesis: Space Game Project Using Delta3D Simulation Engine 2014
 * 
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#pragma once
#define dSINGLE //resolves fatal error C1004: unexpected end-of-file found

#include <cstdio>

#include <dtGUI/gui.h>
#include <dtABC/application.h>
#include <dtCore/actorproxy.h>
#include <dtCore/effectmanager.h>
#include <dtCore/map.h>
#include <dtCore/odebodywrap.h>
#include <dtCore/object.h>
#include <dtCore/project.h>
#include <dtCore/scene.h>
#include <dtCore/system.h>
#include <dtCore/transform.h>
#include <dtCore/deltawin.h>
#include <dtCore/base.h>

#include "sound.h"

#include "json/json-forwards.h"
#include "json/json.h"

class Destructible: public dtCore::Base
{
//Declarations
private:
	struct DestructibleObject
	{
		double	Health;
		dtCore::RefPtr<dtCore::Object> Object;
	};

//Variables
private:
	std::vector<DestructibleObject> DestructibleObjectBuffer;

//Methods
public:
	Destructible::Destructible();
	void Destructible::RegisterDestructibleObjects(dtCore::Map &map);
	bool Destructible::DamageObject(double damage, dtCore::Transformable* damagedObject, dtCore::Scene *scene);
};
