/*****************************************************************************\
 *
 * Author: Sauer Vaclav
 * Email:  xsauer00<at>stud.fit.vutbr.cz
 *
 * Bachelors's thesis: Space Game Project Using Delta3D Simulation Engine 2014
 * 
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#pragma once
#define dSINGLE //resolves fatal error C1004: unexpected end-of-file found

#include <cstdio>

#include <dtCore/refptr.h>
#include <dtCore/object.h>
#include <dtCore/map.h>
#include <dtCore/odebodywrap.h>
#include <dtCore/particlesystem.h>

#include "gui.h"
#include "tower.h"

#include "json/json-forwards.h"
#include "json/json.h"

///Types of missions which may be loaded
enum MISSION
{
	MAIN_MENU,
	BASE,
	//FIRST
};


class Level: public dtCore::Base
{
	//Variables
public:
	bool PlayerDead;
	Tower * m_Tower1;
	Tower * m_Tower2;
	Tower * m_Tower3;
	Tower * m_Tower4;
	Tower * m_Tower5;
	Tower * m_Tower6;
	dtCore::Object * m_Ship1;
	dtCore::Object * m_Ship2;

private:
	Json::Value  *m_Save;
	Gui          *m_Gui;
	double        m_WaitTime;
	bool          m_Wait;
	dtCore::RefPtr<dtCore::Object> m_Player;

	//Methods
public:
	Level::Level(Json::Value * save, Gui * gui);
	void                                   Level::Advance();
	void                                   Level::Update();
	dtCore::RefPtr<dtCore::Object>         Level::GetPlayer(dtCore::Map &map);
	dtCore::RefPtr<dtCore::Object>         Level::GetPlayerShield(dtCore::Map &map);
	dtCore::RefPtr<dtCore::ParticleSystem> Level::GetPlayerEngineParticle(dtCore::Map &map);
	void                                   Level::LoadLevelObjects(dtCore::Map &map);
	void                                   Level::Reset();
	
};