/*****************************************************************************\
 *
 * Author: Sauer Vaclav
 * Email:  xsauer00<at>stud.fit.vutbr.cz
 *
 * Bachelors's thesis: Space Game Project Using Delta3D Simulation Engine 2014
 * 
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#define dSINGLE

#include "game.h"


// ----- MAIN -----------------------------------------------------------------

int main(int arc, char **argv)
{

	dtUtil::SetDataFilePathList(
		"./gamedata/GUI/schemes/;"
		"./gamedata/GUI/imagesets/;"
		"./gamedata/GUI/layouts/;"
		"./gamedata/GUI/looknfeel/;"
		"./gamedata/GUI/fonts/;" ); 
	
	osg::DisplaySettings::instance()->setNumMultiSamples(4);

	dtCore::RefPtr<Game> game = new Game("config/config.xml");

	game->Config();
	game->Run();

	return 0;	
}
