/*****************************************************************************\
 *
 * Author: Sauer Vaclav
 * Email:  xsauer00<at>stud.fit.vutbr.cz
 *
 * Bachelors's thesis: Space Game Project Using Delta3D Simulation Engine 2014
 * 
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#pragma once
#define dSINGLE //resolves fatal error C1004: unexpected end-of-file found

#include <cstdio>
#include <iostream>

#include <dtABC/application.h>
#include <dtCore/base.h>
#include <dtCore/transform.h>
#include <dtCore/object.h>
#include <dtCore/scene.h>
#include <dtCore/system.h>
#include <dtCore/odebodywrap.h>

class Shooter: public dtCore::Base
{
//Definitions
private:
	struct LaserShot
	{
		double						   CreationTime;
		dtCore::RefPtr<dtCore::Object> Model;
	};

//Variables
private:
	static Shooter             *m_Instance;
	dtCore::Scene              *m_Scene;
	std::list<LaserShot>        LaserShotBuffer;

//Methods


public:	
	void Shooter::OnMessage(MessageData *data);	
	void Shooter::ShootLaser(dtCore::Transform *trans, float dispersion = 0);
	void Shooter::CheckLasers();
	
	static Shooter* Shooter::GetInstance();
	Shooter::~Shooter(void);

private:
	Shooter();
	Shooter(const Shooter&);
	Shooter& operator=(const Shooter&);
};