/*****************************************************************************\
 *
 * Author: Sauer Vaclav
 * Email:  xsauer00<at>stud.fit.vutbr.cz
 *
 * Bachelors's thesis: Space Game Project Using Delta3D Simulation Engine 2014
 * 
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#pragma once
#define dSINGLE //resolves fatal error C1004: unexpected end-of-file found

#include <cstdio>

#include <dtABC/application.h>
#include <dtAudio/dtaudio.h>
#include "json/json-forwards.h"
#include "json/json.h"

class Sound
{
//Const
private:
	static const char* MenuButtonPath;
	static const char* LaserShotPath;
	static const char* ExplosionPath;
	
//Variables
private:
	static   Sound*    m_Instance;
	dtAudio::Sound*    m_SoundLaser;
	dtAudio::Sound*    m_SoundMenu;
	dtAudio::Sound*    m_SoundExplosion;


//Methods
public:
	Sound::~Sound(void);
	static void            Sound::OnSoundStopped(dtAudio::Sound* sound, void* param);
	static dtAudio::Sound* Sound::PlayLaserShot();
	static void            Sound::PlayMenuButton();
	static dtAudio::Sound* Sound::PlayExplosion();
	static Sound*          Sound::GetInstance();

private:
	Sound();
	Sound(const Sound&);
	Sound& operator=(const Sound&);
};
