/*****************************************************************************\
 *
 * Author: Sauer Vaclav
 * Email:  xsauer00<at>stud.fit.vutbr.cz
 *
 * Bachelors's thesis: Space Game Project Using Delta3D Simulation Engine 2014
 * 
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, author will kindly welcome
 * if you give him credit and keep his names with their source code
 * and inform him about any succesful project using this code.
 *
\*****************************************************************************/

#pragma once
#define dSINGLE //resolves fatal error C1004: unexpected end-of-file found

#include <cstdio>
#include <iostream>

#include <dtCore/base.h>
#include <dtCore/transform.h>
#include <dtCore/object.h>
#include <dtCore/scene.h>
#include <dtCore/system.h>
#include <dtCore/odebodywrap.h>

#include "shooter.h"
#include "sound.h"

class Tower: public dtCore::Base
{
//Variables
public:
	dtCore::Object  *Model;
private:
	double           m_NextShotTime;
	bool             m_Enraged;
	bool             m_ShootSide;

//Methods
public:	
	Tower::Tower(dtCore::Object *model);
	void Tower::Update(dtCore::RefPtr<dtCore::Object> m_Player, dtCore::Scene *sc, double simTime);
	void Tower::Enrage();
	bool Tower::IsAlive();
};